#
# CacheHandler.py
#
# classes for dealing with object cache
#
# (c) 2004, Davyd Madeley
#

import dircache, cPickle, sys, os

class CacheHandler:
	def __create_name__(self, title, feed):
		return "%s_%s.cache" % (title.replace(' ', '_'), feed.replace(' ', '_').replace('http://', '').replace('/', '_'))
	
	def storeBlog(self, blog):
		name	= self.__create_name__(blog.blogTitle, blog.feedURL)
		# write the blog to disk
		try:
			cPickle.dump(blog, open(os.path.join('cache', name), 'w'))
		except:
			sys.stderr.write('DEBUG: CacheHandler: Item could not be written to cache\n')
	
	def getBlog(self, title, feed):
		name	= self.__create_name__(title, feed)
		# attempt to read the blog from disk
		try:
			blog	= cPickle.load(open(os.path.join('cache', name)))
		except:
			blog	= None
			sys.stderr.write('DEBUG: CacheHandler: Could not read item from cache\n')
		return blog

class CacheObject:
	"Stores Blog objects"
	def __init__(self):
		self.etag	= None
		self.date	= None
